#ifndef BOOST_SMART_PTR_ENABLE_SHARED_FROM_ANY_HPP_INCLUDED
#define BOOST_SMART_PTR_ENABLE_SHARED_FROM_ANY_HPP_INCLUDED

//
//  enable_shared_from_any.hpp
//
//  Copyright 2010 Philip Warner
//
//  Distributed under the Boost Software License, Version 1.0.
//  See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt
//
//  http://www.boost.org/libs/smart_ptr/enable_shared_from_this.html
//

#include <boost/smart_ptr/weak_ptr.hpp>
#include <boost/smart_ptr/shared_ptr.hpp>
#include <boost/assert.hpp>
#include <boost/config.hpp>

namespace boost
{

template<class T> class enable_shared_from_any
{
protected:

    enable_shared_from_any()
    {
    }

    enable_shared_from_any(enable_shared_from_any const &)
    {
    }

    enable_shared_from_any & operator=(enable_shared_from_any const &)
    {
        return *this;
    }

    ~enable_shared_from_any()
    {
    }

public: // actually private, but avoids compiler template friendship issues

    inline weak_ptr<T>& weakPtr() const { return weak_this_; };

private:
    mutable weak_ptr<T> weak_this_;
};

} // namespace boost

#endif  // #ifndef BOOST_SMART_PTR_ENABLE_SHARED_FROM_ANY_HPP_INCLUDED
